package pwc.taxtech.atms.web.controller;


import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dto.ApiResultDto;
import pwc.taxtech.atms.web.service.OrangeHeapService;

import javax.annotation.Resource;
import java.util.Optional;

@RestController
@RequestMapping("/OrangeHeap")
public class OrangeHeapController {

    @Resource
    private OrangeHeapService tableauService;

    private static Logger logger = LoggerFactory.getLogger(OrangeHeapController.class);
    //以上是示范代码
    //TODO 加入其他图表

    // 模板
//    @ResponseBody
//    @GetMapping("taxComparison")
//    public ApiResultDto getTaxComparison() {
//        return ApiResultDto.success(tableauService.getTaxComparison().orElse(StringUtils.EMPTY));
//    }

    @ResponseBody
    @GetMapping("getTableauTaxCategoryUnreturnedTax")
    public ApiResultDto getTableauTaxCategoryUnreturnedTax() {
        logger.info("进入税种未返还税金分析=~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
        return ApiResultDto.success(tableauService.getTableauTaxCategoryUnreturnedTax().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauDistrictUnreturnedTax")
    public ApiResultDto getTableauDistrictUnreturnedTax() {
        logger.info("地区未返还税金分析=~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
        return ApiResultDto.success(tableauService.getTableauDistrictUnreturnedTax().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauUnreturnedAndReturnedTax")
    public ApiResultDto getTableauUnreturnedAndReturnedTax() {
        return ApiResultDto.success(tableauService.getTableauUnreturnedAndReturnedTax().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauCostAnalysis")
    public ApiResultDto getTableauCostAnalysis() {
        return ApiResultDto.success(tableauService.getTableauCostAnalysis().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauDistrictProfitAndLoss")
    public ApiResultDto getTableauDistrictProfitAndLoss() {
        return ApiResultDto.success(tableauService.getTableauDistrictProfitAndLoss().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauCompanyProfitAndLoss")
    public ApiResultDto getTableauCompanyProfitAndLoss() {
        return ApiResultDto.success(tableauService.getTableauCompanyProfitAndLoss().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauDriverAndEmployee")
    public ApiResultDto getTableauDriverAndEmployee() {
        return ApiResultDto.success(tableauService.getTableauDriverAndEmployee().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauGmvAndSubsidy")
    public ApiResultDto getTableauGmvAndSubsidy() {
        return ApiResultDto.success(tableauService.getTableauGmvAndSubsidy().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauFileArrangement")
    public ApiResultDto getTableauFileArrangement() {
        return ApiResultDto.success(tableauService.getTableauFileArrangement().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauGlobalOverview")
    public ApiResultDto getTableauGlobalOverview() {
        return ApiResultDto.success(tableauService.getTableauGlobalOverview().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauGlobalBusiness")
    public ApiResultDto getTableauGlobalBusiness() {
        return ApiResultDto.success(tableauService.getTableauGlobalBusiness().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauMexicanTax")
    public ApiResultDto getTableauMexicanTax() {
        return ApiResultDto.success(tableauService.getTableauMexicanTax().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauAustralianTax")
    public ApiResultDto getTableauAustralianTax() {
        return ApiResultDto.success(tableauService.getTableauAustralianTax().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauBrazilianTax")
    public ApiResultDto getTableauBrazilianTax() {
        return ApiResultDto.success(tableauService.getTableauBrazilianTax().orElse(StringUtils.EMPTY));
    }

    @ResponseBody
    @GetMapping("getTableauOtherTaxAnalysis")
    public ApiResultDto getTableauOtherTaxAnalysis() {
        return ApiResultDto.success(tableauService.getTableauOtherTaxAnalysis().orElse(StringUtils.EMPTY));
    }

}
